//
//  PolygonView.m
//  HelloPolygon
//
//  Created by Kyoung Shin Park on 9/21/11.
//  Copyright 2011 __dis__. All rights reserved.
//

#import "PolygonView.h"


@implementation PolygonView

@synthesize numberOfSides;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
	CGContextRef context = UIGraphicsGetCurrentContext();
	CGMutablePathRef path = CGPathCreateMutable();
	
	CGFloat ctrX = 140.0, ctrY = 140.0, radius = 120.0;
	
	for(int i = 0; i < numberOfSides; i++)
	{
		CGFloat p2x = (ctrX + radius * cosf(((M_PI / 180) * (360.0 / (CGFloat)numberOfSides) * (CGFloat)i)));
		CGFloat p2y = (ctrY + radius * sinf(((M_PI / 180) * (360.0 / (CGFloat)numberOfSides) * (CGFloat)i)));
		
		if(i == 0)
		{
			CGPathMoveToPoint(path, NULL, p2x, p2y);
		}
		else
		{
			CGPathAddLineToPoint(path, NULL, p2x, p2y);
		}
	}
	
	CGContextAddPath(context, path);
	CGContextClosePath(context);
	
	CGContextSetLineWidth(context, 10.0);
	[[UIColor purpleColor] set];
	CGContextStrokePath(context);
	
	[[UIColor grayColor] set];
	CGContextAddPath(context, path);
	CGContextFillPath(context);
	
	CGPathRelease(path);
}

- (void)setNumberOfSides:(NSUInteger)sides
{
	numberOfSides = sides;
    
	[self setNeedsDisplay];
}

@end
